Subject: [rohc] linux constant IP ID field can't be compressed in profile 0x0001?

From: Alan Kennington <[email-masked]>
Date: Thu, 15 May 2003 07:46:36 +0930

Is there an obvious way to solve the problem of the constant value
of the IP header Identifier field for UDP/IP from linux boxes?
As I read it, RFC 3095, 5.7, p.75, says that the difference of the
IP-ID minus the RTP is encoded with p = 0, which means that the _difference_
may be constant or slowly increasing.

Therefore as I understand it, an IP ID field which is always equal to
zero is incompressible.
Can this be right? If so, this is a black mark against linux.

Cheers,
Alan Kennington.

--------------------------------------------------------------------
    name: Dr. Alan Kennington
    city: Adelaide, South Australia
  coords: 34.88051 S, 138.59334 E
timezone: UTC+0930 http://topology.org/timezone.html
 company: Topoz Pty Ltd
 website: http://topoz.net/
_______________________________________________
Rohc mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/rohc

---

From: [email-masked]
Date: Fri, 30 May 2003 14:13:47 -0500

> Since the IP ID field being constant is clearly a pattern, it seems
> reasonable to demand that this pattern should be detected in the normal 
> way patterns are detected. Thus, even if the existing WLSB encoding doesn't 
> compress the constantly zero field very well, the compressor would still 
> be able to send type 0 headers and the decompressor should be able do 
> decompress them. Also for profile 0x0001.
> 
> I believe Zhigang said this about a year ago, and I don't recall any
> protests at that time. Have we since decided to not recognize this pattern?

Thanks for pointing this out, Micke. I cannot remember when I said that
(probably 2 years ago?) but you're certainly right. 

In this case, the pattern of (IP-ID - SN) is slope = -1. So, it only takes
two headers (successfully decompressed) for the decompressor to detect the
pattern. Considering possible packet loss, the compressor only need to send
a few (>2) non-type-0 headers. The overhead due to inefficient IP-ID offset 
encoding only occurs in those headers. In fact, since a few IR packets
(carrying the full value of IP-ID) have to be sent at the beginning of a 
packet flow anyway, there is no additional cost to handle this particular
case.

BR,
Zhigang